% import logging
% logging.info(f'login.tpl: processing template')
%
% import datetime
% import markdown
% rt = 3
% pages = CONFIG['dir_pages']
% login = CONFIG['page_login']
% edit = CONFIG['page_edit']
% wants = QUERY.get('koi_wants', '')
% stay = QUERY.get('koi_stay', '')
% reserved = ['koi_wants', 'koi_stay', 'user', 'password', 'koi_session', 'nonce', 'xCSRF']
% query = '&'.join([f'{k}={v}' for k, v in QUERY.items() if k not in reserved])
% logging.info(f'login.tpl: processing DOCTYPE')
<!DOCTYPE html>
<html lang="en">
  <head>
    % if not (ERR or PROFILE.get('nonce', '')) and wants:
    %   if query:
    %     if PROFILE:
    %       query = '?' + query + f'&xCSRF={PROFILE["xCSRF"]}'
    %     else:
    %       query = '&' + query
    %     end
    %   end
    %   if PROFILE:
          <meta http-equiv="refresh" content="0; URL=/{{pages}}/{{wants}}{{query}}" />
    %   elif not stay:
          <meta http-equiv="refresh" content="{{rt}}; URL=/{{pages}}/{{login}}?koi_wants={{wants}}&koi_stay=1{{query}}" />
    %   end
    % end
    % include('head.tpl')
    <title>{{PAGE['title']}}</title>
  </head>
  <body>
    <div class="container">
    % if ERR:
    %   include('header.tpl', show_search=False, show_login=True, hr=True)
        <p><font class="error">{{ERR}}</font></p>
    % elif wants and not (PROFILE.get('nonce', '') or stay):
        <br><p><font class="error">Login required, redirecting in {{rt}} seconds...</font></p>
    % elif QUERY.get('koi_session', '') == 'logout':
    %   include('header.tpl', show_search=False, show_login=True, hr=True)
        <p>You have successfully logged out. Please click <a href="/">here</a> to return to the main page.</p>
    % elif not PROFILE:
    %   include('header.tpl', show_search=False, show_login=False, hr=True)
        <form action="{{ME['uri']}}" method="post">
    %     if wants:
            <input name="koi_wants" type="hidden" value="{{wants}}">
    %       if query:
    %         for k, v in QUERY.items():
    %           if k not in reserved:
                  <input name="{{k}}" type="hidden" value="{{v}}">
    %           end
    %         end
    %       end
    %     end
          <div class="row">
            <div class="twelve columns">
              <label>username</label>
              <input required name="user" type="text">
            </div>
          </div>
          <div class="row">
            <div class="twelve columns">
              <label>password</label>
              <input required name="password" type="password">
            </div>
          </div>
          <div class="row">
            <div class="twelve columns">
              <button class="button-primary" name="koi_session" type="submit" value="login">login</button>
            </div>
          </div>
        </form>
    % elif PROFILE:
    %   include('header.tpl', show_search=True, show_login=False, hr=True)
    %   if PROFILE['nonce']:
          <form action="{{ME['uri']}}" method="post">
    %       if wants:
              <input name="koi_wants" type="hidden" value="{{wants}}">
    %         if query:
    %           for k, v in QUERY.items():
    %             if k not in reserved:
                    <input name="{{k}}" type="hidden" value="{{v}}">
    %             end
    %           end
    %         end
    %       end
            <input name="koi_session" type="hidden" value="chknonce">
    %       if PROFILE['multiF_check']['twoF_totp'] and PROFILE['multiF_check']['twoF_email']:
              <label>EMAIL-TOTP dual verification code (email nonce first, no spaces)</label>
              <span title="EMAIL_nonce-TOTP_nonce">
                <input required name="nonce" placeholder="NNNNNN-NNNNNN">
              </span>
    %       else:
    %         if PROFILE['multiF_check']['twoF_totp']:
    %           origin='TOTP'
    %         else:
    %           origin='EMAIL'
    %         end
              <label>{{origin}} verification code (no spaces)</label>
              <span title="nonce">
                <input required name="nonce" placeholder="NNNNNN" type="number">
              </span>
    %       end
            <br><button class="button-primary" type="submit">submit</button>
          </form>
    %   else:
    %     name = PROFILE['name']
    %     if not name:
    %       name = PROFILE['user']
    %     end
    %     xCSRF = f'<input name="xCSRF" type="hidden" value="{PROFILE["xCSRF"]}">'
    %     content = PAGE['body'].replace('{{!xCSRF}}', xCSRF)
    %     if 'editor' in PROFILE['roles'].get(edit, []) and not edit.startswith('.'):
            <div class="row navstrip">
              <div class="twelve columns">
                <a class="button" href="/{{pages}}/{{edit}}">editor</a>
              </div>
            </div>
    %     end
          <div class="row">
            <div class="twelve columns">
              <p>Welcome <k>{{name}}</k>!</p>
              {{!markdown.markdown(content)}}
            </div>
          </div>
    %   end
    % else:
    %   include('header.tpl', show_search=False, show_login=True, hr=False)
        <p><font class="error">unexpected request</font></p>
    % end
    </div>
  </body>
</html>
