% import logging
% user = PROFILE.get('user','')
% log_id = f'{ME["template"]+".tpl"}: {user}'
% logging.info(f'{log_id}: processing template')
% max_len = CONFIG['search_max_query_len']
% search_var = CONFIG['search_var']
% num_hits = CONFIG['search_num_hits']
% search_scope = ['title', 'keywords', 'body', 'author', 'creator']
%
% ##########################################################################
%
% def do_search(search_query):
%   """
    do_search(search_query[str]) -> matches[dict]

    Search the site INDEX for matches on "search_query"
    (a string of space-separated words).
"""
%   logging.debug(f'{log_id}: executing "do_search({search_query})"')
%   import re
%   import copy
%   punctuation = re.compile(r'[\W_]+')
%   search_query = punctuation.sub(' ', search_query)
%   search_words = set([i.lower() for i in search_query.split()])
%   matches = copy.deepcopy(INDEX)
%   logging.info(f'{log_id}: searching the INDEX')
%   for page, entries in INDEX.items():
%     if not TREE[page]['serve']:
%       logging.debug(f'{log_id}: skipping restricted page "{page}"')
%       del matches[page]
%       continue
%     end
%     match = False
%     for scope in search_scope:
%       # entries is INDEX[page]
%       if scope in entries and isinstance(entries[scope], str):
%         logging.debug(f'{log_id}: searching "{page}[\'{scope}\']"')
%         entry = punctuation.sub(' ', entries[scope])
%         entry_words = set([i.lower() for i in entry.split()])
%         if search_words.issubset(entry_words):
%           logging.debug(f'{log_id}: found match')
%           match = True
%           break
%         end
%       end
%     end
%     if not match:
%       del matches[page]
%     end
%   end
% return matches
% end
%
% ##########################################################################
%
% logging.debug(f'{log_id}: processing DOCTYPE')
<!DOCTYPE html>
<html lang="en">
  <head>
    % include('head.tpl')
    <title>{{PAGE['title']}}</title>
  </head>
  <body>
    <div class="container">
      % include('header.tpl', show_search=True, show_login=True, hr=True)
% ##########################################################################
      % if not search_var in QUERY:
          <p>No query found, try using the search field above</p>
% ##########################################################################
      % else:
      %   search_query = QUERY[search_var]
      %   logging.debug(f'{log_id}: parsing query "{search_query}"')
      %   if not search_query:
      %     logging.debug(f'{log_id}: empty search query, no matches returned')
            <p>No results on empty query</p>
      %   elif len(search_query) > max_len:
      %     msg = f'{log_id}: refusing search query exceeding {0} characters'
      %     logging.debug(msg.format(max_len))
            <p>Sorry, that search query is too long</p>
      %   else:
      %     matches = do_search(search_query)
      %     if not matches:
              <p>No matches found for <em>{{search_query}}</em></p>
      %     else:
      %       hits = len(matches)
      %       if hits == 1:
      %         suf = ''
      %       else:
      %         suf='es'
      %       end
      %       if len(matches) > num_hits:
      %         showing=f'(showing the first {num_hits} entries)'
      %       else:
      %         showing=''
      %       end
              <p>Found {{hits}} match{{suf}} for <em>{{search_query}}</em> {{showing}}</p>
              <ol>
      %         count = 0
      %         for page, entries in matches.items():
      %           uri = TREE[page]['uri']
      %           title = entries.get('title', '')
      %           if not title:
      %             title = f'uri > {uri}'
      %           end
                  <li><a class="button" href="{{uri}}">{{title}}</a></li>
      %           count+=1
      %           if count == num_hits:
      %             break
      %           end
      %         end
              </ol>
      %     end
      %   end
      % end
    </div>
  </body>
</html>
